/* iRiver iFP 7XX Emulator
   Copyright (C) 2005 Tomasz Malesinski <tmal@mimuw.edu.pl>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include <stdlib.h>
#include "event.h"

static struct event *event_list;

static int before(unsigned int t1, unsigned int t2) {
  return (t2 - t1) < 0x80000000U;
}

void init_events(void) {
  event_list = NULL;
}

void add_event(struct event *e) {
  struct event *f = event_list;
  if (!f || before(e->tick, f->tick)) {
    e->next = f;
    event_list = e;
  } else {
    while (f->next && before(f->next->tick, e->tick))
      f = f->next;
    e->next = f->next;
    f->next = e;
  }
}

void handle_events(unsigned int tick) {
  while (event_list && !before(tick, event_list->tick)) {
    struct event *e = event_list;
    event_list = event_list->next;
    (*(e->f))(e);
  }
}
