/* iRiver iFP 7XX Emulator
   Copyright (C) 2006 Tomasz Malesinski <tmal@mimuw.edu.pl>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef _FLASH_H_
#define _FLASH_H_

#include "emuriver.h"

#define FLASH_256_8 0
#define FLASH_512_8 1
#define FLASH_1024_8 2

struct flash {
  int model;
  uint8 reg[2112];
  int offset;
  int page;
  int ptr;
  int adr_ptr;
  int only_oob;
  FILE *fp;

  int busy, ready_tick;

  uint8 adr[5];
  uint8 cmd;
};

struct flash *create_flash(int model, char *fname, int offset);
void free_flash(struct flash *flash);
uint8 flash_read(struct flash *flash, int adr);
void flash_write(struct flash *flash, int adr, uint8 val);

#endif
